package client.cam;

import java.applet.Applet;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.GraphicsConfiguration;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Toolkit;
import java.awt.image.VolatileImage;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.nio.ByteBuffer;
import java.text.DecimalFormat;
import java.util.Date;

public class ImageView extends Applet implements Runnable
{
	int								interval			= 10;
	String							imgName			= "img.jpg";
	URL								imgURL;
	Thread							myThread;
	Image								img;
	String							str_rate			= "loading ";
	VolatileImage					vimage;
	int								width;
	int								height;
	int								rposx				= 0;
	int								rposy				= 0;
	boolean							absolute_flg_x	= true;
	boolean							absolute_flg_y	= true;
	DecimalFormat					exFormat1		= new DecimalFormat("##########.0");
	int								img_width		= 0;
	int								img_height		= 0;
	Image								reimg;
	boolean							resize_flg		= true;
	private volatile boolean	menAtWork		= true;

	public void init()
	{
		this.getInitParm();
		if (this.myThread == null)
		{
			this.myThread = new Thread(this);
		}
	}

	public void start()
	{
		if (this.myThread != null)
		{
			this.myThread.start();
		}
	}

	public void stop()
	{
		if (this.myThread != null)
		{
			this.menAtWork = false;
			while (!this.menAtWork)
			{
				this.myThread.interrupt();
			}
		}
	}

	public void destroy()
	{
		this.myThread = null;
	}

	public void getInitParm()
	{
		String string;
		String string2 = this.getParameter("interval");
		if (string2 != null)
		{
			this.interval = Integer.valueOf(string2);
		}
		if ((string2 = this.getParameter("image_width")) != null)
		{
			this.img_width = Integer.valueOf(string2);
		}
		if ((string2 = this.getParameter("image_height")) != null)
		{
			this.img_height = Integer.valueOf(string2);
		}
		this.resize_flg = this.img_height > 0 && this.img_width > 0;
		string2 = this.getParameter("speed_pos_x");
		if (string2 != null)
		{
			string = string2.substring(0, 1);
			if (string.compareTo("+") == 0)
			{
				this.absolute_flg_x = false;
				string2 = string2.substring(1);
			}
			if (string.compareTo("-") == 0)
			{
				this.absolute_flg_x = false;
			}
			this.rposx = Integer.valueOf(string2);
		}
		if ((string2 = this.getParameter("speed_pos_y")) != null)
		{
			string = string2.substring(0, 1);
			if (string.compareTo("+") == 0)
			{
				this.absolute_flg_y = false;
				string2 = string2.substring(1);
			}
			if (string.compareTo("-") == 0)
			{
				this.absolute_flg_y = false;
			}
			this.rposy = Integer.valueOf(string2);
		}
		if ((string2 = this.getParameter("image")) != null)
		{
			this.imgName = string2;
		}
		try
		{
			this.imgURL = new URL(this.getDocumentBase(), this.imgName);
			this.img = this.getImage(this.imgURL);
			if (this.resize_flg)
			{
				this.reimg = this.img.getScaledInstance(this.img_width, this.img_height, 2);
			}
		}
		catch (MalformedURLException malformedURLException)
		{
			// empty catch block
		}
	}

	private void initVolatileImage()
	{
		if (this.vimage == null || this.width != this.getWidth() || this.height != this.getHeight())
		{
			this.width = this.getWidth();
			this.height = this.getHeight();
			this.vimage = this.createVolatileImage(this.width, this.height);
		}
	}

	private void validateVolatileImage()
	{
		GraphicsConfiguration graphicsConfiguration = this.getGraphicsConfiguration();
		if (this.vimage.validate(graphicsConfiguration) == 2)
		{
			this.vimage = this.createVolatileImage(this.width, this.height);
		}
	}

	public void update(Graphics graphics)
	{
		this.paint(graphics);
	}

	public void paint(Graphics graphics)
	{
		this.initVolatileImage();
		try
		{
			do
			{
				this.validateVolatileImage();
				this.draw();
				graphics.drawImage(this.vimage, 0, 0, this);
			}
			while (this.vimage.contentsLost());
		}
		catch (NullPointerException nullPointerException)
		{
			// empty catch block
		}
	}

	public void draw()
	{
		int n;
		int n2;
		Image image;
		Graphics graphics = this.vimage.getGraphics();
		if (this.resize_flg)
		{
			image = this.reimg;
			synchronized (image)
			{
				graphics.drawImage(this.reimg, 0, 0, this);
				n2 = this.reimg.getHeight(this);
				n = this.reimg.getWidth(this);
			}
		}
		image = this.img;
		synchronized (image)
		{
			graphics.drawImage(this.img, 0, 0, this);
			n2 = this.img.getHeight(this);
			n = this.img.getWidth(this);
		}
		int n3 = this.absolute_flg_x ? this.rposx : n + this.rposx;
		int n4 = this.absolute_flg_y ? this.rposy : n2 + this.rposy;
		graphics.setColor(Color.white);
		graphics.fillRect(n3, n4, 100, 14);
		graphics.setColor(Color.black);
		int n5 = this.str_rate.length();
		graphics.drawString(this.str_rate, n3 + (20 - n5 - 3) * 7 - 9, n4 + 10);
		graphics.dispose();
	}

	public void run()
	{
		long l = 0;
		long l2 = 0;
		this.menAtWork = true;
		while (this.menAtWork)
		{
			try
			{
				HttpURLConnection httpURLConnection = this.makeConnection(this.imgURL);
				int n = httpURLConnection.getContentLength();
				byte[] arrby = new byte[n];
				int n2 = 0;
				n2 = this.loadImg(httpURLConnection, arrby, n);
				httpURLConnection.disconnect();
				this.makeImg(arrby);
				if ((this.checkImage(this.img, this) & 64) == 0)
				{
					this.makeReImg();
					l2 = new Date().getTime();
					if (l != 0 && l != l2)
					{
						double d = (double) n2 / ((double) (l2 - l) * 0.001) / 1024.0 * 8.0;
						this.str_rate = this.exFormat1.format(d) + "[Kbps]";
					}
					l = l2;
					Graphics graphics = this.getGraphics();
					this.update(graphics);
				}
				Thread.sleep(this.interval);
			}
			catch (Exception exception)
			{
			}
		}
		this.menAtWork = true;
	}

	public HttpURLConnection makeConnection(URL uRL)
	{
		HttpURLConnection httpURLConnection = null;
		try
		{
			httpURLConnection = (HttpURLConnection) uRL.openConnection();
			httpURLConnection.setRequestMethod("GET");
			httpURLConnection.setUseCaches(false);
		}
		catch (Exception exception)
		{
			// empty catch block
		}
		return httpURLConnection;
	}

	public int loadImg(HttpURLConnection httpURLConnection, byte[] arrby, int n)
	{
		int n2 = 0;
		try
		{
			int n3;
			InputStream inputStream = httpURLConnection.getInputStream();
			byte[] arrby2 = new byte[n];
			ByteBuffer byteBuffer = ByteBuffer.wrap(arrby);
			while ((n3 = inputStream.read(arrby2)) != -1)
			{
				byteBuffer.put(arrby2, 0, n3);
				n2 += n3;
			}
			inputStream.close();
		}
		catch (Exception exception)
		{
			exception.printStackTrace();
		}
		return n2;
	}

	public void makeImg(byte[] arrby)
	{
		MediaTracker mediaTracker = new MediaTracker(this);
		Image image = this.img;
		synchronized (image)
		{
			if (this.img != null)
			{
				this.img.flush();
			}
			this.img = Toolkit.getDefaultToolkit().createImage(arrby);
			mediaTracker.addImage(this.img, 0);
			try
			{
				mediaTracker.waitForID(0);
			}
			catch (InterruptedException interruptedException)
			{
				// empty catch block
			}
		}
	}

	public void makeReImg()
	{
		if (this.resize_flg)
		{
			MediaTracker mediaTracker = new MediaTracker(this);
			Image image = this.reimg;
			synchronized (image)
			{
				if (this.reimg != null)
				{
					this.reimg.flush();
				}
				this.reimg = this.img.getScaledInstance(this.img_width, this.img_height, 2);
				mediaTracker.addImage(this.img, 1);
				try
				{
					mediaTracker.waitForID(1);
				}
				catch (InterruptedException interruptedException)
				{
					// empty catch block
				}
			}
		}
	}
}